﻿; Icon Source https://www.iconfinder.com/icons/17893/download_manager_icon#size=128
; XYplorer DL by Enternal for XYplorer
; http://www.purebasic.fr/english/viewtopic.php?f=19&t=44256
; http://users.ugent.be/~bpuype/wget/ - OLD WGet
; http://nebm.ist.utl.pt/~glopes/wget/ - New WGet (Supports SSL)
InitNetwork()
SetCurrentDirectory(GetPathPart(ProgramFilename()))
Global Date$ = FormatDate("%yyyy-%mm-%dd %hh.%ii.%ss",Date())
FileName$ = "XYplorer "+Date$+".zip"

If FileSize("WGet.exe") = -1
	MessageRequester("CRITICAL ERROR!","WGet.exe Missing. Cannot Continue.",#PB_MessageRequester_Ok)
	End
EndIf

Procedure ConnectionCheck(FileUrl$)
	Global Header$ = GetHTTPHeader(FileUrl$)
	Status$ = StringField(Header$,1,#CRLF$)
	If Status$ = ""
		OpenFile(0,"XYplorerDL_Log.txt",#PB_File_Append)
		;FileSeek(0,Lof(0))
		WriteStringN(0,Date$+" FAILED! No Internet or XYplorer Server Down")
		CloseFile(0)
		End
	ElseIf FindString(Header$, "200 OK") = 0
		OpenFile(0,"XYplorerDL_Log.txt",#PB_File_Append)
		;FileSeek(0,Lof(0))
		HTTPFail$ = Date$+" ERROR! "+Status$
		WriteStringN(0,HTTPFail$)
		CloseFile(0)
		End
	EndIf
EndProcedure

If FileSize("XYplorerDL_Log.txt") <> -1
Else
	CreateFile(0,"XYplorerDL_Log.txt")
EndIf

If FileSize("XYplorerDL_Debug.txt") <> -1
	OpenFile(0,"XYplorerDL_Log.txt",#PB_File_Append)
	SuccessLog$ = Date$+" Debug - Windows Task Checker"
	WriteStringN(0,SuccessLog$)
	CloseFile(0)
Else
EndIf

ConnectionCheck("https://www.xyplorer.com/version.php")
ReceiveHTTPFile("https://www.xyplorer.com/version.php","XYplorerDL_Version.txt")
OpenFile(0,"XYplorerDL_Version.txt")
Version$ = ReadString(0)
Version$ = RSet(Version$,5)
CloseFile(0)
DeleteFile("XYplorerDL_Version.txt")
FileUrl$ = "https://www.xyplorer.com/download/xyplorer_"+Version$+"_beta_noinstall.zip"
ConnectionCheck(FileUrl$)
;Debug Header$
;ETag$ = Mid(Header$,FindString(Header$, "ETag"),29) - Old Method
ETag$ = StringField(Header$,8,#CRLF$)
ETag$ = RemoveString(ETag$,#CRLF$)
;Debug ETag$
Command$ = "--no-check-certificate "+"-O "+#DQUOTE$+FileName$+#DQUOTE$+" "+FileUrl$

If FileSize("XYplorerDL_ETag.txt") <> -1
	OpenFile(0,"XYplorerDL_ETag.txt")
	ETagFile$ = ReadString(0)
	CloseFile(0)
ElseIf FileSize("XYplorerDL_ETag.txt") = -1
	OpenFile(0,"XYplorerDL_ETag.txt")
	WriteString(0,ETag$)
	CloseFile(0)
	RunProgram("WGet.exe",Command$,"",#PB_Program_Wait)
	OpenFile(0,"XYplorerDL_Log.txt",#PB_File_Append)
	SuccessLog$ = "|"+FileName$+"| Downloaded Successfully!"
	WriteStringN(0,SuccessLog$)
	CloseFile(0)
	End
EndIf

If ETag$ = ETagFile$
	End
Else
	;Debug Command$
	If RunProgram("WGet.exe",Command$,"",#PB_Program_Wait)
		OpenFile(0,"XYplorerDL_ETag.txt")
		FileSeek(0,0)
		TruncateFile(0)
		WriteString(0,ETag$)
		CloseFile(0)
		OpenFile(0,"XYplorerDL_Log.txt",#PB_File_Append)
		SuccessLog$ = "|"+FileName$+"| Downloaded Successfully!"
		WriteStringN(0,SuccessLog$)
		CloseFile(0)
		End
	Else
		OpenFile(0,"XYplorerDL_Log.txt",#PB_File_Append)
		FailLog$ = "|"+FileName$+"| Download Failed!"
		WriteStringN(0,FailLog$)
		CloseFile(0)
		End
	EndIf
EndIf
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 17
; Folding = -
; EnableUnicode
; EnableThread
; EnableXP
; UseIcon = 1379998689_17893.ico
; Executable = XYplorerDL.exe
; DisableDebugger
; CompileSourceDirectory
; IncludeVersionInfo
; VersionField0 = 1.0.6.0
; VersionField1 = 1.0.6.0
; VersionField3 = XYplorerDL
; VersionField4 = 1.0.6
; VersionField5 = 1.0.6
; VersionField6 = XYplorer Downloader
; VersionField7 = XYplorerDL
; VersionField8 = XYplorerDL.exe
; VersionField14 = http://www.xyplorer.com/xyfc/index.php
; VersionField18 = Author
; VersionField21 = Enternal from XYplorer